/*   
    
    Ec  Vers  2.9.1-1    Copyright (C)   2001 Marc Dechico

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    To contact the author:	Marc Dechico
			        Kerfring
			        29390 SCAER France
				tel: 06 80 83 74 99
				Mail: Marc.DECHICO@wanadoo.fr
    
*/

#include "ec_data.h"

/*****************************************************************************/
/*  Simulation:  detemine le meilleur coup  jouer......?!                   */
/*****************************************************************************/

void simul  (void)
{
	/* tst */ char tst= 'O';
	/* la simulation commence a pro_act + 1*/

	i_pro_sim_act		= i_pro_act;

	i_pro_sim_max_sup	=               	/* profondeur de sim max */
		i_pro_act + i_pro_sim_niv;  		/* pour aff_hst */

	i_pro_sim_max_inf	=               	/* profondeur de sim max */
		i_pro_sim_max_sup + i_pro_sim_inc;  /* pour aff_hst */

	if(i_pro_sim_niv >2)                    /* profondeur d'interruption */
	{                                       /* clavier  */
		i_pro_sim_int_cla	=
			i_pro_sim_max_sup -2;
	}
	else
	{
		i_pro_sim_int_cla	=
			i_pro_sim_max_sup -1;

	}
	pro_sui();

	/* initialisation variables  */
	not_mvt_ini_raz();                       /* init de cpt pat mat 		*/
	i_not_cpt_mvt_ini 			= 0;         /* compteur mvt initiaux 		*/
	i_sim_end 					= 0;         /* controle boucle simulation 	*/
	cpt = 0;
	while (i_sim_end ==0 )
	{
		/* tst
		if(tst== 'O' && ts_ech[6][9].i_Id==6)
		{
		    aff_hst(0,10); 
		    tst='N';
		}*/
		 cpt++;
		/* restore pice secondaire si fct existe */
		/*bug typ mvt est-il reinitialise par pro suivante ?*/
		if(tpf_res_pie_sec[pts_hst_pro->i_typ_mvt])
			 (*tpf_res_pie_sec[pts_hst_pro->i_typ_mvt])();


		(**pts_hst_pro->ptpf_mvt)();


	}
	/* reinitialisation du  pionteurs sur hst */
	pts_hst_pro 	= &ts_hst_pro[i_pro_act];
	pts_hst_pro_p 	= &ts_hst_pro[i_pro_act-1];
	/* initialisation du  pionteurs piece actuelle  */
	pts_pie =
	tpts_pie[pts_hst_pro->i_cam]+pts_hst_pro->i_Id;



}
void not_mvt_ini_raz(void)
{
	int x;
	for(x=0;x<150;x++)
	{
		ts_not_mvt_ini[x].ti_nbr_pat[0] = 0;
		ts_not_mvt_ini[x].ti_nbr_pat[1] = 0;
		ts_not_mvt_ini[x].ti_nbr_mat[0] = 0;
		ts_not_mvt_ini[x].ti_nbr_mat[1] = 0;
	}
}

/* fonctions calculant pour chaque direction  les nouvelles coordonnes       */
/* de la pice  partir de sa positin precedente                             */
void haut 			(void)
{
	(pts_hst_pro->i_pos_y)++;
	mvt_tfr();
}
void haut_droite  	(void)
{
	(pts_hst_pro->i_pos_x)++;
	(pts_hst_pro->i_pos_y)++;
	mvt_tfr();
}
void droite 		(void)
{
	(pts_hst_pro->i_pos_x)++;
	mvt_tfr();
}
void bas_droite  	(void)
{
	(pts_hst_pro->i_pos_x)++;
	(pts_hst_pro->i_pos_y)--;
	mvt_tfr();
}
void bas 			(void)
{
	(pts_hst_pro->i_pos_y)--;
	mvt_tfr();
}
void bas_gauche 	(void)
{
	(pts_hst_pro->i_pos_x)--;
	(pts_hst_pro->i_pos_y)--;
	mvt_tfr();
}
void gauche 		(void)
{
	(pts_hst_pro->i_pos_x)--;
	mvt_tfr();
}
void haut_gauche 	(void)
{
	(pts_hst_pro->i_pos_x)--;
	(pts_hst_pro->i_pos_y)++;
	mvt_tfr();
}
/* cas particulier pour gestion du rock */
void haut_tou_pr  	(void)
{
	(pts_hst_pro->i_pos_y)++;
	mvt_tou_pr();
}
void bas_tou_pr  	(void)
{
	(pts_hst_pro->i_pos_y)--;
	mvt_tou_pr();
}
void haut_tou_gr  	(void)
{
	(pts_hst_pro->i_pos_y)++;
	mvt_tou_gr();
}
void bas_tou_gr  	(void)
{
	(pts_hst_pro->i_pos_y)--;
	mvt_tou_gr();
}
void gauche_tou_pr 	(void)
{
	(pts_hst_pro->i_pos_x)--;
	mvt_tou_pr();
}
void droite_tou_gr 	(void)
{
	(pts_hst_pro->i_pos_x)++;
	mvt_tou_gr();
}
void mvt_tfr 		(void)
{
	if(ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y].i_cam == -1)
	{
		/* deplacement simple */
		pts_hst_pro->i_typ_mvt 	= 0;
		/* reinit pour retour profondeur inferieur */
		pts_hst_pro->i_dir_sui 	= 0;
		dep_sim();
	}
	else
	{
		if (ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y].i_cam==
		pts_hst_pro->i_cam_adv)
		{
			/* prise simple */
			pts_hst_pro->i_typ_mvt = 1;
			pts_hst_pro->i_dir_sui = 1;
			pri_sim();
		}
		else
		{
			/* pice propre camp ou autre */
			pts_hst_pro->i_not = NOT_MIN;
			dir_sui();
			return;
		}
	}

	/* echec pro precedente ?*/
	if (pts_hst_pro_p->i_ech==1)
	{
		/* verife  nouveau echec */
		/* 		par pice principale ou secondaire pro precedente ? */
		/* 	ou  par demasquage pro precedente ? */
		/* 	ou  par demasquage prof actuelle */

		if
		(
			(
					/* principale/ secondaire */
				tpf_cas_ctl_sta[pts_hst_pro_p->i_ech_dir_pri]
				&&
				(*tpf_cas_ctl_sta[pts_hst_pro_p->i_ech_dir_pri])
									(pts_hst_pro->i_pos_x_R_p_c,
									 pts_hst_pro->i_pos_y_R_p_c,
									 pts_hst_pro->i_cam_adv)
			)
		||
			(
					/* demasaquage pro precedente */
				tpf_cas_ctl_sta[pts_hst_pro_p->i_ech_dir_dem]
				&&
				(*tpf_cas_ctl_sta[pts_hst_pro_p->i_ech_dir_dem])
									(pts_hst_pro->i_pos_x_R_p_c,
									 pts_hst_pro->i_pos_y_R_p_c,
									 pts_hst_pro->i_cam_adv)
			)
		||
			(
					/* demasquage pro actuelle */
				tpf_cas_ctl_sta[pts_hst_pro->i_ech_dir_dem_p_c]
				&&
				(*tpf_cas_ctl_sta[pts_hst_pro->i_ech_dir_dem_p_c])
									(pts_hst_pro->i_pos_x_R_p_c,
									 pts_hst_pro->i_pos_y_R_p_c,
									 pts_hst_pro->i_cam_adv)
			)
		)

		{
			/* echec donc mvt impossible */
			pts_hst_pro->i_not = NOT_MIN;
			if(pts_hst_pro->i_dir_sui)
				dir_sui();
			return;
		}
		else	/* roi n'est plus echec  */
		{
			/* roi n'est plus echec donc mat = N  */
			pts_hst_pro_p->i_mat = 0;

		}

	}
	else  	/* pas d'echec prof precedente */
	{
		/* Verifie echec propre camp par demasquage  */
		if
		(
			tpf_cas_ctl_sta[pts_hst_pro->i_ech_dir_dem_p_c]
			&&
			(*tpf_cas_ctl_sta[pts_hst_pro->i_ech_dir_dem_p_c])
									(pts_hst_pro->i_pos_x_R_p_c,
									 pts_hst_pro->i_pos_y_R_p_c,
									 pts_hst_pro->i_cam_adv)
		)

		{
			/* echec donc mvt impossible */
			pts_hst_pro->i_not = NOT_MIN;
			/* dir sui car ne peut prendre la piece causant echec */
			dir_sui();
			return;
		}
		else     /* pas d'echec */
		{

			/* roi ne se retrouve pas echec donc pat = N  */
			pts_hst_pro_p->i_pat = 0;

		}
	}
	if
	(
	i_pro_sim_act<i_pro_sim_max_sup
	||
	(
	ti_typ_mvt_pri[pts_hst_pro->i_typ_mvt]
	&&
	i_pro_sim_act<i_pro_sim_max_inf
	)
	)
	{
		/* verifie si cause echec camp adverse */
		/* par mvt pice principale ou par demasquage*/
		if
		(
			(*pts_pie->pf_ech_par)
					(pts_hst_pro->i_pos_x,
					 pts_hst_pro->i_pos_y,
					&(pts_hst_pro->i_ech_dir_pri))
			||
			(
				tpf_cas_ctl_sta[pts_hst_pro->i_ech_dir_dem]
				&&
				(*tpf_cas_ctl_sta[pts_hst_pro->i_ech_dir_dem])
									(pts_hst_pro->i_pos_x_R_c_a,
									 pts_hst_pro->i_pos_y_R_c_a,
									 pts_hst_pro->i_cam)
		
							/* optimisation supprimer parametre? i_camp */
			)
		)
		{
		   pts_hst_pro->i_ech=1;
		   pts_hst_pro->i_mat=1;
		   pts_hst_pro->i_pat=0;

		}
		else
		{
		   pts_hst_pro->i_ech=0;
		   pts_hst_pro->i_mat=0;
		   pts_hst_pro->i_pat=1;
		}


		/* descendre ds l'arborescence */
		pro_sui();

		/* recopie valeur grd et petit rock pour cam propre */
		cop_val_prc_pc();
		cop_val_grc_pc();

		/* recopie valeur grd et petit rock pour cam adverse */

		cop_val_prc_ca();
		cop_val_grc_ca();

	}
	else
	{

		/* mise  jour note max */
		if(pts_hst_pro->i_not>pts_hst_pro->i_not_max)
			pts_hst_pro->i_not_max =pts_hst_pro->i_not;

		/* direction suivante mme pro */
		if(pts_hst_pro->i_dir_sui)
			dir_sui();
		return;
	}

}
/* pour tour se trouvant en position d'origine et maj ti_cam_roc */
void mvt_tou_pr 		(void)
{
	if(ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y].i_cam == -1)
	{
		/* deplacement simple */
		pts_hst_pro->i_typ_mvt 	= 0;
		/* reinit pour retour profondeur inferieur */
		pts_hst_pro->i_dir_sui 	= 0;
		dep_sim();
	}
	else
	{
		if (ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y].i_cam==
		pts_hst_pro->i_cam_adv)
		{
			/* prise simple */
			pts_hst_pro->i_typ_mvt = 1;
			/*? pourquoi avoir  utilise hst si utilisation immediate */
			pts_hst_pro->i_dir_sui = 1;
			pri_sim();
		}
		else
		{
			/* pice propre camp ou autre */
			pts_hst_pro->i_not = NOT_MIN;
			dir_sui();
			return;
		}
	}

	/* echec pro precedente ?*/
	if (pts_hst_pro_p->i_ech==1)
	{
		/* verife  nouveau echec */
		/* 		par pice principale pro precedente ? */
		/* 	ou	par pice secondaire pro precedente */
		/* 	ou  par demasquage pro precedente ? */
		/* 	ou  par demasquage prof actuelle */

		if
		(
			(
				tpf_cas_ctl_sta[pts_hst_pro_p->i_ech_dir_pri]
				&&
				(*tpf_cas_ctl_sta[pts_hst_pro_p->i_ech_dir_pri])
									(pts_hst_pro->i_pos_x_R_p_c,
									 pts_hst_pro->i_pos_y_R_p_c,
									 pts_hst_pro->i_cam_adv)
			)
		||
			(
				tpf_cas_ctl_sta[pts_hst_pro_p->i_ech_dir_dem]
				&&
				(*tpf_cas_ctl_sta[pts_hst_pro_p->i_ech_dir_dem])
									(pts_hst_pro->i_pos_x_R_p_c,
									 pts_hst_pro->i_pos_y_R_p_c,
									 pts_hst_pro->i_cam_adv)
			)
		||
			(
				tpf_cas_ctl_sta[pts_hst_pro->i_ech_dir_dem_p_c]
				&&
				(*tpf_cas_ctl_sta[pts_hst_pro->i_ech_dir_dem_p_c])
									(pts_hst_pro->i_pos_x_R_p_c,
									 pts_hst_pro->i_pos_y_R_p_c,
									 pts_hst_pro->i_cam_adv)
			)
		)

		{
			/* echec donc mvt impossible */
			pts_hst_pro->i_not = NOT_MIN;
			if(pts_hst_pro->i_dir_sui)
				dir_sui();
			return;
		}
		else	/* roi n'est plus echec  */
		{
			/* roi n'est plus echec donc mat = N  */
			pts_hst_pro_p->i_mat = 0;

		}

	}
	else  	/* pas d'echec prof precedente */
	{
		/* Verifie echec propre camp par demasquage  */
		if
		(
			tpf_cas_ctl_sta[pts_hst_pro->i_ech_dir_dem_p_c]
			&&
			(*tpf_cas_ctl_sta[pts_hst_pro->i_ech_dir_dem_p_c])
									(pts_hst_pro->i_pos_x_R_p_c,
									 pts_hst_pro->i_pos_y_R_p_c,
									 pts_hst_pro->i_cam_adv)
		)

		{
			/* echec donc mvt impossible */
			pts_hst_pro->i_not = NOT_MIN;
			/* dir sui car ne peut prendre la piece causant echec */
			dir_sui();
			return;
		}
		else     /* pas d'echec */
		{

			/* roi ne se retrouve pas echec donc pat = N  */
			pts_hst_pro_p->i_pat = 0;

		}
	}
	if
	(
	i_pro_sim_act<i_pro_sim_max_sup
	||
	(
	ti_typ_mvt_pri[pts_hst_pro->i_typ_mvt]
	&&
	i_pro_sim_act<i_pro_sim_max_inf
	)
	)
	{
		/* verifie si cause echec camp adverse */
		/* par mvt pice principale ou par demasquage*/
		if
		(
			(*pts_pie->pf_ech_par)
					(pts_hst_pro->i_pos_x,
					 pts_hst_pro->i_pos_y,
					&(pts_hst_pro->i_ech_dir_pri))
			||
			(
				tpf_cas_ctl_sta[pts_hst_pro->i_ech_dir_dem]
				&&
				(*tpf_cas_ctl_sta[pts_hst_pro->i_ech_dir_dem])
									(pts_hst_pro->i_pos_x_R_c_a,
									 pts_hst_pro->i_pos_y_R_c_a,
									 pts_hst_pro->i_cam)
			)
		)
		{
		   pts_hst_pro->i_ech=1;
		   pts_hst_pro->i_mat=1;
		   pts_hst_pro->i_pat=0;

		}
		else
		{
		   pts_hst_pro->i_ech=0;
		   pts_hst_pro->i_mat=0;
		   pts_hst_pro->i_pat=1;
		}

		/* descendre ds l'arborescence */
		pro_sui();

		/* recopie valeur grd et petit rock pour cam propre */
		/*  petit rock plus possible: modife valeur par defaut */
		pts_hst_pro->
		ti_roc_cam_typ[pts_hst_pro_p->i_cam][PET_ROC]= 1;
		cop_val_grc_pc();

		/* recopie valeur grd et petit rock pour cam adverse */

		cop_val_prc_ca();
		cop_val_grc_ca();

	}
	else
	{

		/* mise  jour note max */
		if(pts_hst_pro->i_not>pts_hst_pro->i_not_max)
			pts_hst_pro->i_not_max =pts_hst_pro->i_not;

		/* direction suivante mme pro */
		if(pts_hst_pro->i_dir_sui)
			dir_sui();
		return;
	}

}
void mvt_tou_gr 		(void)
{
	if(ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y].i_cam == -1)
	{
		/* deplacement simple */
		pts_hst_pro->i_typ_mvt 	= 0;
		/* reinit pour retour profondeur inferieur */
		pts_hst_pro->i_dir_sui 	= 0;
		dep_sim();
	}
	else
	{
		if (ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y].i_cam==
		pts_hst_pro->i_cam_adv)
		{
			/* prise simple */
			pts_hst_pro->i_typ_mvt = 1;
			pts_hst_pro->i_dir_sui = 1;
			pri_sim();
		}
		else
		{
			/* pice propre camp ou autre */
			pts_hst_pro->i_not = NOT_MIN;
			dir_sui();
			return;
		}
	}

	/* echec pro precedente ?*/
	if (pts_hst_pro_p->i_ech==1)
	{
		/* verife  nouveau echec */
		/* 		par pice principale pro precedente ? */
		/* 	ou	par pice secondaire pro precedente ? */
		/* 	ou  par demasquage pro precedente ? */
		/* 	ou  par demasquage prof actuelle */

		if
		(
			(
				tpf_cas_ctl_sta[pts_hst_pro_p->i_ech_dir_pri]
				&&
				(*tpf_cas_ctl_sta[pts_hst_pro_p->i_ech_dir_pri])
									(pts_hst_pro->i_pos_x_R_p_c,
									 pts_hst_pro->i_pos_y_R_p_c,
									 pts_hst_pro->i_cam_adv)
			)
		||
			(
				tpf_cas_ctl_sta[pts_hst_pro_p->i_ech_dir_dem]
				&&
				(*tpf_cas_ctl_sta[pts_hst_pro_p->i_ech_dir_dem])
									(pts_hst_pro->i_pos_x_R_p_c,
									 pts_hst_pro->i_pos_y_R_p_c,
									 pts_hst_pro->i_cam_adv)
			)
		||
			(
				tpf_cas_ctl_sta[pts_hst_pro->i_ech_dir_dem_p_c]
				&&
				(*tpf_cas_ctl_sta[pts_hst_pro->i_ech_dir_dem_p_c])
									(pts_hst_pro->i_pos_x_R_p_c,
									 pts_hst_pro->i_pos_y_R_p_c,
									 pts_hst_pro->i_cam_adv)
			)
		)

		{
			/* echec donc mvt impossible */
			pts_hst_pro->i_not = NOT_MIN;
			if(pts_hst_pro->i_dir_sui)
				dir_sui();
			return;
		}
		else	/* roi n'est plus echec  */
		{
			/* roi n'est plus echec donc mat = N  */
			pts_hst_pro_p->i_mat = 0;

		}

	}
	else  	/* pas d'echec prof precedente */
	{
		/* Verifie echec propre camp par demasquage  */
		if
		(
			tpf_cas_ctl_sta[pts_hst_pro->i_ech_dir_dem_p_c]
			&&
			(*tpf_cas_ctl_sta[pts_hst_pro->i_ech_dir_dem_p_c])
									(pts_hst_pro->i_pos_x_R_p_c,
									 pts_hst_pro->i_pos_y_R_p_c,
									 pts_hst_pro->i_cam_adv)
		)

		{
			/* echec donc mvt impossible */
			pts_hst_pro->i_not = NOT_MIN;
			/* dir sui car ne peut prendre la piece causant echec */
			dir_sui();
			return;
		}
		else     /* pas d'echec */
		{

			/* roi ne se retrouve pas echec donc pat = N  */
			pts_hst_pro_p->i_pat = 0;

		}
	}
	if
	(
	i_pro_sim_act<i_pro_sim_max_sup
	||
	(
	ti_typ_mvt_pri[pts_hst_pro->i_typ_mvt]
	&&
	i_pro_sim_act<i_pro_sim_max_inf
	)
	)
	{
		/* verifie si cause echec camp adverse */
		/* par mvt pice principale ou par demasquage*/
		if
		(
			(*pts_pie->pf_ech_par)
					(pts_hst_pro->i_pos_x,
					 pts_hst_pro->i_pos_y,
					&(pts_hst_pro->i_ech_dir_pri))
			||
			(
				tpf_cas_ctl_sta[pts_hst_pro->i_ech_dir_dem]
				&&
				(*tpf_cas_ctl_sta[pts_hst_pro->i_ech_dir_dem])
									(pts_hst_pro->i_pos_x_R_c_a,
									 pts_hst_pro->i_pos_y_R_c_a,
									 pts_hst_pro->i_cam)
			)
		)
		{
		   pts_hst_pro->i_ech=1;
		   pts_hst_pro->i_mat=1;
		   pts_hst_pro->i_pat=0;

		}
		else
		{
		   pts_hst_pro->i_ech=0;
		   pts_hst_pro->i_mat=0;
		   pts_hst_pro->i_pat=1;
		}

		/* descendre ds l'arborescence */
		pro_sui();

		/* recopie valeur grd et petit rock pour cam propre */
		cop_val_prc_pc();
		/* grd  rock plus possible: modife valeur par defaut */
		pts_hst_pro->
		ti_roc_cam_typ[pts_hst_pro_p->i_cam][GRA_ROC]= 1;

		/* recopie valeur grd et petit rock pour cam adverse */
		cop_val_prc_ca();
		cop_val_grc_ca();

	}
	else
	{

		/* mise  jour note max */
		if(pts_hst_pro->i_not>pts_hst_pro->i_not_max)
			pts_hst_pro->i_not_max =pts_hst_pro->i_not;

		/* direction suivante mme pro */
		if(pts_hst_pro->i_dir_sui)
			dir_sui();
		return;
	}

}

/* pour cavalier */
void haut_droite_C 	(void)
{
	(pts_hst_pro->i_pos_x)+=1;
	(pts_hst_pro->i_pos_y)+=2;
	mvt_cav();

}
void droite_haut_C 	(void)
{
	(pts_hst_pro->i_pos_x)+=2;
	(pts_hst_pro->i_pos_y)+=1;
	mvt_cav();

}
void droite_bas_C 	(void)
{
	(pts_hst_pro->i_pos_x)+=2;
	(pts_hst_pro->i_pos_y)-=1;
	mvt_cav();

}
void bas_droite_C 	(void)
{
	(pts_hst_pro->i_pos_x)+=1;
	(pts_hst_pro->i_pos_y)-=2;
	mvt_cav();

}
void bas_gauche_C 	(void)
{
	(pts_hst_pro->i_pos_x)-=1;
	(pts_hst_pro->i_pos_y)-=2;
	mvt_cav();

}
void gauche_bas_C 	(void)
{
	(pts_hst_pro->i_pos_x)-=2;
	(pts_hst_pro->i_pos_y)-=1;
	mvt_cav();

}

void gauche_haut_C	(void)
{
	(pts_hst_pro->i_pos_x)-=2;
	(pts_hst_pro->i_pos_y)+=1;
	mvt_cav();

}
void haut_gauche_C  (void)
{
	(pts_hst_pro->i_pos_x)-=1;
	(pts_hst_pro->i_pos_y)+=2;
	mvt_cav();

}
void mvt_cav 		(void)
{
	if(ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y].i_cam == -1)
	{
		/* deplacement simple */
		pts_hst_pro->i_typ_mvt 	= 0;
		dep_sim();
	}
	else
	{
		if (ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y].i_cam==
		pts_hst_pro->i_cam_adv)
		{
			/* prise simple */
			pts_hst_pro->i_typ_mvt = 1;
			pri_sim();
		}
		else
		{
			/* pice propre camp ou autre */
			pts_hst_pro->i_not = NOT_MIN;
			dir_sui();
			return;
		}
	}

	/* echec pro precedente ?*/
	if (pts_hst_pro_p->i_ech==1)
	{
		/* verife  nouveau echec */
		/* 		par pice principale pro precedente ? */
		/* 	ou	par pice secondaire pro precedente ? */
		/* 	ou  par demasquage pro precedente ? */
		/* 	ou  par demasquage prof actuelle */

		if
		(
			(
				tpf_cas_ctl_sta[pts_hst_pro_p->i_ech_dir_pri]
				&&
				(*tpf_cas_ctl_sta[pts_hst_pro_p->i_ech_dir_pri])
									(pts_hst_pro->i_pos_x_R_p_c,
									 pts_hst_pro->i_pos_y_R_p_c,
									 pts_hst_pro->i_cam_adv)
			)
		||
			(
				tpf_cas_ctl_sta[pts_hst_pro_p->i_ech_dir_dem]
				&&
				(*tpf_cas_ctl_sta[pts_hst_pro_p->i_ech_dir_dem])
									(pts_hst_pro->i_pos_x_R_p_c,
									 pts_hst_pro->i_pos_y_R_p_c,
									 pts_hst_pro->i_cam_adv)
			)
		||
			(
				tpf_cas_ctl_sta[pts_hst_pro->i_ech_dir_dem_p_c]
				&&
				(*tpf_cas_ctl_sta[pts_hst_pro->i_ech_dir_dem_p_c])
									(pts_hst_pro->i_pos_x_R_p_c,
									 pts_hst_pro->i_pos_y_R_p_c,
									 pts_hst_pro->i_cam_adv)
			)
		)

		{
			/* echec donc mvt impossible */
			pts_hst_pro->i_not = NOT_MIN;
			dir_sui();
			return;
		}
		else	/* roi n'est plus echec  */
		{
			/* roi n'est plus echec donc mat = N  */
			pts_hst_pro_p->i_mat = 0;

		}

	}
	else  	/* pas d'echec prof precedente */
	{
		/* Verifie echec propre camp par demasquage  */
		if
		(
			tpf_cas_ctl_sta[pts_hst_pro->i_ech_dir_dem_p_c]
			&&
			(*tpf_cas_ctl_sta[pts_hst_pro->i_ech_dir_dem_p_c])
									(pts_hst_pro->i_pos_x_R_p_c,
									 pts_hst_pro->i_pos_y_R_p_c,
									 pts_hst_pro->i_cam_adv)
		)

		{
			/* echec donc mvt impossible */
			pts_hst_pro->i_not = NOT_MIN;
			dir_sui();
			return;
		}
		else     /* pas d'echec */
		{

			/* roi ne se retrouve pas echec donc pat = N  */
			pts_hst_pro_p->i_pat = 0;

		}
	}
	if
	(
	i_pro_sim_act<i_pro_sim_max_sup
	||
	(
	ti_typ_mvt_pri[pts_hst_pro->i_typ_mvt]
	&&
	i_pro_sim_act<i_pro_sim_max_inf
	)
	)

	{
		/* verifie si cause echec camp adverse */
		/* par mvt pice principale ou par demasquage*/
		if
		(
			ech_par_cav (pts_hst_pro->i_pos_x,
						 pts_hst_pro->i_pos_y,
						&(pts_hst_pro->i_ech_dir_pri))
			||
			(
				tpf_cas_ctl_sta[pts_hst_pro->i_ech_dir_dem]
				&&
				(*tpf_cas_ctl_sta[pts_hst_pro->i_ech_dir_dem])
									(pts_hst_pro->i_pos_x_R_c_a,
									 pts_hst_pro->i_pos_y_R_c_a,
									 pts_hst_pro->i_cam)
			)
		)
		{
		   pts_hst_pro->i_ech=1;
		   pts_hst_pro->i_mat=1;
		   pts_hst_pro->i_pat=0;

		}
		else
		{
		   pts_hst_pro->i_ech=0;
		   pts_hst_pro->i_mat=0;
		   pts_hst_pro->i_pat=1;
		}


		/* descendre ds l'arborescence */
		pro_sui();


		/* recopie valeur grd et petit rock pour cam propre */
		cop_val_prc_pc();
		cop_val_grc_pc();

		/* recopie valeur grd et petit rock pour cam adverse */
		cop_val_prc_ca();
		cop_val_grc_ca();


	}
	else
	{

		/* mise  jour note max */
		if(pts_hst_pro->i_not>pts_hst_pro->i_not_max)
			pts_hst_pro->i_not_max =pts_hst_pro->i_not;

		/* direction suivante mme pro */
		dir_sui();
		return;
	}

}

/* pour roi */
void haut_gauche_R 	(void)
{
	(pts_hst_pro->i_pos_x)--;
	(pts_hst_pro->i_pos_y)++;
	mvt_roi();

}
void haut_droite_R 	(void)
{
	(pts_hst_pro->i_pos_x)++;
	(pts_hst_pro->i_pos_y)++;
	mvt_roi();

}
void bas_gauche_R 	(void)
{
	(pts_hst_pro->i_pos_x)--;
	(pts_hst_pro->i_pos_y)--;
	mvt_roi();


}
void bas_droite_R  	(void)
{
	(pts_hst_pro->i_pos_x)++;
	(pts_hst_pro->i_pos_y)--;
	mvt_roi();

}
void haut_R 		(void)
{
	(pts_hst_pro->i_pos_y)++;
	mvt_roi();

}
void bas_R			(void)
{
	(pts_hst_pro->i_pos_y)--;
	mvt_roi();

}
void gauche_R 		(void)
{
	(pts_hst_pro->i_pos_x)--;
	mvt_roi();

}
void droite_R 		(void)
{
	(pts_hst_pro->i_pos_x)++;
	mvt_roi();

}
void grd_roc_0 	(void)
{

	/* restore pice principale */
	if(tpf_res_pie_pri[pts_hst_pro->i_typ_mvt])
	{
		 (*tpf_res_pie_pri[pts_hst_pro->i_typ_mvt]) 	();
	}

	pts_hst_pro->i_pos_x =4;

	if
	(
	pts_hst_pro->i_cam != BLANC  		 /* blanc */
	||
	pts_hst_pro->
	ti_roc_cam_typ[BLANC][GRA_ROC]!=0	 /* roi ou tour deplace */
	||
	ts_ech[2][2].i_Id!=
	  ti_tou_cam_typ[BLANC][GRA_ROC]	 /* tour supprime car pas deplace*/
	||
	pts_hst_pro_p->i_ech				 /* echec prof precedente */
	||
	ts_ech[3][2].i_cam!=-1			   	 /* case intermedaire  non vide*/
	||
	ts_ech[4][2].i_cam!=-1
	||
	ts_ech[5][2].i_cam!=-1
	||
	(*pf_cas_ctl_pos[3][2])	(3,2)        /* ou sous ctl adversaire */
	||
	(*pf_cas_ctl_pos[4][2])	(4,2)
	||
	(*pf_cas_ctl_pos[5][2])	(5,2)
	)
	{
		pts_hst_pro->i_not = NOT_MIN;
		dir_sui();
	}
	else					/* roc possible */
	{
		pts_hst_pro->i_typ_mvt = 12;                /*grd rock */
		pts_hst_pro_p->i_pat   = 0;                 /* pas d'echec poss*/
		dep_grd_roc_0();                            /* mvt des pices */
		mvt_roi_gra_roc(5,2);
	}

}
void grd_roc_1 	(void)
{

	/* restore pice principale */
	if(tpf_res_pie_pri[pts_hst_pro->i_typ_mvt])
	{
		 (*tpf_res_pie_pri[pts_hst_pro->i_typ_mvt]) 	();
	}

	pts_hst_pro->i_pos_x =4;

	if
	(
	pts_hst_pro->i_cam != NOIR			  /* noir  */
	||
	pts_hst_pro->
	ti_roc_cam_typ[NOIR][GRA_ROC] 		  /* roi ou tour deplace */
	||
	ts_ech[2][9].i_Id!=
	  ti_tou_cam_typ[NOIR][GRA_ROC]	   	 /* tour supprime car pas deplace*/
	||
	pts_hst_pro_p->i_ech	    		  /* echec prof precedente */
	||
	ts_ech[3][9].i_cam!=-1			   	  /* case intermedaire non vide*/
	||
	ts_ech[4][9].i_cam!=-1
	||
	ts_ech[5][9].i_cam!=-1
	||
	(*pf_cas_ctl_pos[3][9])	(3,9)         /*  ou sous ctl adversaire */
	||
	(*pf_cas_ctl_pos[4][9])	(4,9)
	||
	(*pf_cas_ctl_pos[5][9])	(5,9)
	)
	{
		pts_hst_pro->i_not = NOT_MIN;
		dir_sui();
	}
	else					/* roc possible */
	{
		pts_hst_pro->i_typ_mvt = 12;                /* grand rock */
		pts_hst_pro_p->i_pat   = 0;                 /* pas d'echec poss*/
		dep_grd_roc_1();                            /* mvt des pices */
		mvt_roi_gra_roc(5,9);
	}
}
void pet_roc_0 	(void)
{

	/* restore pice principale */
	if(tpf_res_pie_pri[pts_hst_pro->i_typ_mvt])
	{
		 (*tpf_res_pie_pri[pts_hst_pro->i_typ_mvt]) 	();
	}

	pts_hst_pro->i_pos_x =8;

	if
	(
	pts_hst_pro->i_cam != BLANC  		 /* blanc */
	||
	pts_hst_pro->
	ti_roc_cam_typ[BLANC][PET_ROC] 		 /* roi ou tour deplace */
	||
	ts_ech[9][2].i_Id!=
	  ti_tou_cam_typ[BLANC][PET_ROC]	 /* tour supprime car pas deplace*/
	||
	pts_hst_pro_p->i_ech				 /* echec prof precedente */
	||
	ts_ech[7][2].i_cam!=-1			   	 /* case intermedaire non vide*/
	||
	ts_ech[8][2].i_cam!=-1
	||
	(*pf_cas_ctl_pos[7][2])	(7,2)        /* ou sous ctl adversaire */
	||
	(*pf_cas_ctl_pos[8][2])	(8,2)
	)
	{
		pts_hst_pro->i_not = NOT_MIN;
		dir_sui();
	}
	else					/* roc possible */
	{
		pts_hst_pro->i_typ_mvt = 11;                /*petit rock */
		pts_hst_pro_p->i_pat   = 0;                 /* pas d'echec poss*/
		dep_pet_roc_0();                            /* mvt des pices */
		mvt_roi_pet_roc(7,2);
	}
}
void pet_roc_1 	(void)
{
	/* restore pice principale */
	if(tpf_res_pie_pri[pts_hst_pro->i_typ_mvt])
	{
		 (*tpf_res_pie_pri[pts_hst_pro->i_typ_mvt]) 	();
	}


	pts_hst_pro->i_pos_x =8;

	if
	(
	pts_hst_pro->i_cam != NOIR  		 /* noir */
	||
	pts_hst_pro->
	ti_roc_cam_typ[NOIR][PET_ROC] 		 /* roi ou tour deplace */
	||
	ts_ech[9][9].i_Id!=
	  ti_tou_cam_typ[NOIR][PET_ROC]	   	 /* tour supprime car pas deplace*/
	||
	pts_hst_pro_p->i_ech				 /* echec prof precedente */
	||
	ts_ech[7][9].i_cam!=-1			   	 /* case intermedaire non vide*/
	||
	ts_ech[8][9].i_cam!=-1
	||
	(*pf_cas_ctl_pos[7][9])	(7,9)        /* ou sous ctl adversaire */
	||
	(*pf_cas_ctl_pos[8][9])	(8,9)
	)
	{
		pts_hst_pro->i_not = NOT_MIN;
		dir_sui();
	}
	else					/* roc possible */
	{
		pts_hst_pro->i_typ_mvt = 11;                /*petit rock */
		pts_hst_pro_p->i_pat   = 0;                 /* pas d'echec poss*/
		dep_pet_roc_1();                            /* mvt des pices */
		mvt_roi_pet_roc(7,9);
	}

}
void mvt_roi_gra_roc 		(int i_pos_x_tou,int i_pos_y_tou)
{
	if 	(i_pro_sim_act<i_pro_sim_max_sup)

	{
		/* verifie si cause echec camp adverse */
		/* par la tour */
		if
		(
			ech_par_tou
			(
			i_pos_x_tou,
			i_pos_y_tou,
			&(pts_hst_pro->i_ech_dir_pri)
			)
		)
		{
		   pts_hst_pro->i_ech=1;
		   pts_hst_pro->i_mat=1;
		   pts_hst_pro->i_pat=0;

		}
		else
		{
		   pts_hst_pro->i_ech=0;
		   pts_hst_pro->i_mat=0;
		   pts_hst_pro->i_pat=1;
		}


		/* descendre ds l'arborescence */
		pro_sui();

		/* recopie valeur grd et petit rock pour cam propre */
		/* petit et grd rock plus possible */
		pts_hst_pro->
		ti_roc_cam_typ[pts_hst_pro_p->i_cam][PET_ROC]= 1;
		pts_hst_pro->
		ti_roc_cam_typ[pts_hst_pro_p->i_cam][GRA_ROC]= 1;

		/* recopie valeur grd et petit rock pour cam adverse */
		cop_val_prc_ca();
		cop_val_grc_ca();




	}
	else
	{
		 /* mise  jour note max */
		if(pts_hst_pro->i_not>pts_hst_pro->i_not_max)
			pts_hst_pro->i_not_max =pts_hst_pro->i_not;

		/* direction suivante mme pro */
		dir_sui();
		return;
	}

}
void mvt_roi_pet_roc 		(int i_pos_x_tou,int i_pos_y_tou)
{
	if 	(i_pro_sim_act<i_pro_sim_max_sup)

	{
		/* verifie si cause echec camp adverse */
		/* par la tour */
		if
		(
			ech_par_tou
			(
			i_pos_x_tou,
			i_pos_y_tou,
			&(pts_hst_pro->i_ech_dir_pri)
			)
		)
		{
		   pts_hst_pro->i_ech=1;
		   pts_hst_pro->i_mat=1;
		   pts_hst_pro->i_pat=0;

		}
		else
		{
		   pts_hst_pro->i_ech=0;
		   pts_hst_pro->i_mat=0;
		   pts_hst_pro->i_pat=1;
		}


		/* descendre ds l'arborescence */
		pro_sui();


		/* recopie valeur grd et petit rock pour cam propre */
		/* petit et grd rock plus possible */
		pts_hst_pro->
		ti_roc_cam_typ[pts_hst_pro_p->i_cam][PET_ROC]= 1;
		pts_hst_pro->
		ti_roc_cam_typ[pts_hst_pro_p->i_cam][GRA_ROC]= 1;

		/* recopie valeur grd et petit rock pour cam adverse */
		cop_val_prc_ca();
		cop_val_grc_ca();


	}
	else
	{
		 /* mise  jour note max */
		if(pts_hst_pro->i_not>pts_hst_pro->i_not_max)
			pts_hst_pro->i_not_max =pts_hst_pro->i_not;

		/* direction suivante mme pro */
		dir_sui();
		return;
	}

}
void mvt_roi 		(void)
{
	if(ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y].i_cam == -1)
	{
		/* deplacement simple */
		pts_hst_pro->i_typ_mvt 	= 0;
		dep_sim();
	}
	else
	{
		if (ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y].i_cam==
		pts_hst_pro->i_cam_adv)
		{
			/* prise simple */
			pts_hst_pro->i_typ_mvt = 1;
			pri_sim();
		}
		else
		{
			/* pice propre camp ou autre */
			pts_hst_pro->i_not = NOT_MIN;
			dir_sui();
			return;
		}
	}

	/* echec pro precedente ?*/
	if (pts_hst_pro_p->i_ech==1)
	{
		/* verifie si roi  nouveau echec (toute direction )*/
		if ((*pf_cas_ctl_pos[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y])
					(pts_hst_pro->i_pos_x,pts_hst_pro->i_pos_y) )
		{
			/* echec donc mvt impossible */
			pts_hst_pro->i_not = NOT_MIN;
			dir_sui();
			return;
		}
		else    /* roi n'est plus echec */
		{
			/* roi n'est plus echec donc mat = N  */
			pts_hst_pro_p->i_mat = 0;
		}

	}
	else  /* pas d'echec pro precedente */
	{
		/* verifie si roi se retrouve echec (toute direction )*/
		if ((*pf_cas_ctl_pos[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y])
				(pts_hst_pro->i_pos_x,pts_hst_pro->i_pos_y)   )
		{
			/* echec donc mvt impossible */
			pts_hst_pro->i_not = NOT_MIN;
			dir_sui();
			return;
		}
		else
		{
			/* roi ne se retrouve pas echec donc pat = N  */
			pts_hst_pro_p->i_pat = 0;
		}
	}

	if
	(
	i_pro_sim_act<i_pro_sim_max_sup
	||
	(
	ti_typ_mvt_pri[pts_hst_pro->i_typ_mvt]
	&&
	i_pro_sim_act<i_pro_sim_max_inf
	)
	)

	{
		/* verifie si cause echec camp adverse */
		/* par par demasquage*/
		if
		(
			tpf_cas_ctl_sta[pts_hst_pro->i_ech_dir_dem]
			&&
			(*tpf_cas_ctl_sta[pts_hst_pro->i_ech_dir_dem])
								(pts_hst_pro->i_pos_x_R_c_a,
								 pts_hst_pro->i_pos_y_R_c_a,
								 pts_hst_pro->i_cam)
		)
		{
		   pts_hst_pro->i_ech=1;
		   pts_hst_pro->i_mat=1;
		   pts_hst_pro->i_pat=0;

		}
		else
		{
		   pts_hst_pro->i_ech=0;
		   pts_hst_pro->i_mat=0;
		   pts_hst_pro->i_pat=1;
		}


		/* descendre ds l'arborescence */
		pro_sui();

		/* recopie valeur grd et petit rock pour cam propre */
		/* petit et grd rock plus possible */
		pts_hst_pro->
		ti_roc_cam_typ[pts_hst_pro_p->i_cam][PET_ROC]= 1;
		pts_hst_pro->
		ti_roc_cam_typ[pts_hst_pro_p->i_cam][GRA_ROC]= 1;

		/* recopie valeur grd et petit rock pour cam adverse */
		cop_val_prc_ca();
		cop_val_grc_ca();


	}
	else
	{
		 /* mise  jour note max */
		if(pts_hst_pro->i_not>pts_hst_pro->i_not_max)
			pts_hst_pro->i_not_max =pts_hst_pro->i_not;

		/* direction suivante mme pro */
		dir_sui();
		return;
	}
}

/* pour pion camp 0 */

void haut_1_p_0 	(void)
{
	(pts_hst_pro->i_pos_y)+=1;

	if(ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y].i_cam == VIDE)
	{
		/* deplacement simple */
		pts_hst_pro->i_typ_mvt 	= MVT_DEP_SIM;
		dep_sim();
	}
	else
	{
			/* pice propre camp ou autre */
			pts_hst_pro->i_not = NOT_MIN;
			dir_sui();
			return;
	}
	mvt_pio();
}
void haut_2_p_0		(void)
{

	/* restore pice principale */
	/* pouurait tre vit en changeant l'ordre des fct des tpf_mvt_pio */
	if(tpf_res_pie_pri[pts_hst_pro->i_typ_mvt])
	{
		 (*tpf_res_pie_pri[pts_hst_pro->i_typ_mvt]) 	();
	}
	(pts_hst_pro->i_pos_y)+=2;

	if
	(
		ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y].i_cam == VIDE
		&&
		ts_ech[pts_hst_pro->i_pos_x][(pts_hst_pro->i_pos_y)-1].i_cam == VIDE

	)
	{
		/* deplacement simple */
		pts_hst_pro->i_typ_mvt 	= MVT_DEP_SIM;
		dep_sim();
	}
	else
	{
			/* pice propre camp ou autre */
			pts_hst_pro->i_not = NOT_MIN;
			dir_sui();
			return;
	}
	mvt_pio();
}
void haut_gauche_p_0(void)
{
	(pts_hst_pro->i_pos_x)-=1;
	(pts_hst_pro->i_pos_y)+=1;

	if(ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y].i_cam == NOIR)
	{
		/* prise simple  */
		pts_hst_pro->i_typ_mvt 	= MVT_PRI_SIM;
		pri_sim();
	}
	else
	{
			/* pice propre camp ou autre */
			pts_hst_pro->i_not = NOT_MIN;
			dir_sui();
			return;
	}
	mvt_pio();
}
void haut_droite_p_0(void)
{
	(pts_hst_pro->i_pos_x)+=1;
	(pts_hst_pro->i_pos_y)+=1;

	if(ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y].i_cam == NOIR)
	{
		/* prise simple  */
		pts_hst_pro->i_typ_mvt 	= MVT_PRI_SIM;
		pri_sim();
	}
	else
	{
			/* pice propre camp ou autre */
			pts_hst_pro->i_not = NOT_MIN;
			dir_sui();
			return;
	}
	mvt_pio();
}
void haut_gauche_pas_p_0(void)
{
	(pts_hst_pro->i_pos_x)-=1;
	(pts_hst_pro->i_pos_y)+=1;

	if
	(
		(tpts_pie[NOIR]+pts_hst_pro_p->i_Id)->c_typ_pie == 'P'
		&&
		/*  test position de dpart du pion  prendre */
		pts_hst_pro_p->i_pos_ori_x == pts_hst_pro->i_pos_x
		&&
		pts_hst_pro_p->i_pos_ori_y == l7
		&&
		/* test position d'arrive du pion  prendre   */
		pts_hst_pro_p->i_pos_x == pts_hst_pro->i_pos_x
		&&
		pts_hst_pro_p->i_pos_y == l5

	)
	{
		/* prise simple  */
		pts_hst_pro->i_typ_mvt 	= MVT_PRI_PAS;
		pri_pas();
	}
	else
	{
			/* pice propre camp ou autre */
			pts_hst_pro->i_not = NOT_MIN;
			dir_sui();
			return;
	}
	mvt_pio();
}
void haut_droite_pas_p_0(void)
{
	(pts_hst_pro->i_pos_x)+=1;
	(pts_hst_pro->i_pos_y)+=1;

	if
	(
		(tpts_pie[NOIR]+pts_hst_pro_p->i_Id)->c_typ_pie == 'P'
		&&
		/*  test position de dpart du pion  prendre */
		pts_hst_pro_p->i_pos_ori_x == pts_hst_pro->i_pos_x
		&&
		pts_hst_pro_p->i_pos_ori_y == l7
		&&
		/* test position d'arrive du pion  prendre   */
		pts_hst_pro_p->i_pos_x == pts_hst_pro->i_pos_x
		&&
		pts_hst_pro_p->i_pos_y == l5

	)
	{
		/* prise simple  */
		pts_hst_pro->i_typ_mvt 	= MVT_PRI_PAS;
		pri_pas();
	}
	else
	{
			/* pice propre camp ou autre */
			pts_hst_pro->i_not = NOT_MIN;
			dir_sui();
			return;
	}
	mvt_pio();
}
void haut_gauche_cav_p_0(void)
{
	(pts_hst_pro->i_pos_x)-=1;
	(pts_hst_pro->i_pos_y)+=1;

	if(ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y].i_cam == NOIR)
	{
		/* prise simple  */
		pts_hst_pro->i_typ_mvt 	= MVT_PRI_PIO_CAV;
		pri_sim();

		/* transforme le pion en cavalier */
		pts_pie->i_for			= 2;
		pts_pie->pf_ini_hst_mvt = ini_hst_mvt_cav;
		pts_pie->pf_jou         = jou_ctfr;
		pts_pie->pf_ech_par     = ech_par_cav;
		pts_pie->i_mvt_uni_dir  = 1;
		pts_pie->c_typ_pie      = 'C';
		pts_pie->c_lib_pie      = 'C';

	}
	else
	{
			/* piece propre camp ou autre */
			pts_hst_pro->i_not = NOT_MIN;
			dir_sui();
			return;
	}
	mvt_pio();
}
void haut_droite_cav_p_0(void)
{
	(pts_hst_pro->i_pos_x)+=1;
	(pts_hst_pro->i_pos_y)+=1;

	if(ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y].i_cam == NOIR)
	{
		/* prise simple  */
		pts_hst_pro->i_typ_mvt 	= MVT_PRI_PIO_CAV;
		pri_sim();

		/* transforme le pion en cavalier */
		pts_pie->i_for			= 2;
		pts_pie->pf_ini_hst_mvt = ini_hst_mvt_cav;
		pts_pie->pf_jou         = jou_ctfr;
		pts_pie->pf_ech_par     = ech_par_cav;
		pts_pie->i_mvt_uni_dir  = 1;
		pts_pie->c_typ_pie      = 'C';
		pts_pie->c_lib_pie      = 'C';

	}
	else
	{
			/* piece propre camp ou autre */
			pts_hst_pro->i_not = NOT_MIN;
			dir_sui();
			return;
	}
	mvt_pio();
}
void haut_cav_p_0 	(void)
{
	(pts_hst_pro->i_pos_y)+=1;

	if(ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y].i_cam == VIDE)
	{
		/* deplacement simple */
		pts_hst_pro->i_typ_mvt 	= MVT_PIO_CAV;
		dep_sim();

		/* transforme le pion en cavalier */
		pts_pie->i_for			= 2;
		pts_pie->pf_ini_hst_mvt = ini_hst_mvt_cav;
		pts_pie->pf_jou         = jou_ctfr;
		pts_pie->pf_ech_par     = ech_par_cav;
		pts_pie->i_mvt_uni_dir  = 1;
		pts_pie->c_typ_pie      = 'C';
		pts_pie->c_lib_pie      = 'C';
	}
	else
	{
			/* piece propre camp ou autre */
			pts_hst_pro->i_not = NOT_MIN;
			dir_sui();
			return;
	}
	mvt_pio();
}
void haut_gauche_rei_p_0(void)
{
	(pts_hst_pro->i_pos_x)-=1;
	(pts_hst_pro->i_pos_y)+=1;

	if(ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y].i_cam == NOIR)
	{
		/* prise simple  */
		pts_hst_pro->i_typ_mvt 	= MVT_PRI_PIO_REI;
		pri_sim();

		/* transforme le pion en reine  */
		pts_pie->i_for			= 4;
		pts_pie->pf_ini_hst_mvt = ini_hst_mvt_rei;
		pts_pie->pf_jou         = jou_ctfr;
		pts_pie->pf_ech_par     = ech_par_rei;
		pts_pie->i_mvt_uni_dir  = 0;
		pts_pie->c_typ_pie      = 'D';
		pts_pie->c_lib_pie      = 'D';

	}
	else
	{
			/* piece propre camp ou autre */
			pts_hst_pro->i_not = NOT_MIN;
			dir_sui();
			return;
	}
	mvt_pio();
}
void haut_droite_rei_p_0(void)
{
	(pts_hst_pro->i_pos_x)+=1;
	(pts_hst_pro->i_pos_y)+=1;

	if(ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y].i_cam == NOIR)
	{
		/* prise simple  */
		pts_hst_pro->i_typ_mvt 	= MVT_PRI_PIO_REI;
		pri_sim();

		/* transforme le pion en reine  */
		pts_pie->i_for			= 4;
		pts_pie->pf_ini_hst_mvt = ini_hst_mvt_rei;
		pts_pie->pf_jou         = jou_ctfr;
		pts_pie->pf_ech_par     = ech_par_rei;
		pts_pie->i_mvt_uni_dir  = 0;
		pts_pie->c_typ_pie      = 'D';
		pts_pie->c_lib_pie      = 'D';
	}
	else
	{
			/* piece propre camp ou autre */
			pts_hst_pro->i_not = NOT_MIN;
			dir_sui();
			return;
	}
	mvt_pio();
}
void haut_rei_p_0 	(void)
{

	(pts_hst_pro->i_pos_y)+=1;

	if(ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y].i_cam == VIDE)
	{
		/* deplacement simple */
		pts_hst_pro->i_typ_mvt 	= MVT_PIO_REI;
		dep_sim();

		/* transforme le pion en reine  */
		pts_pie->i_for			= 4;
		pts_pie->pf_ini_hst_mvt = ini_hst_mvt_rei;
		pts_pie->pf_jou         = jou_ctfr;
		pts_pie->pf_ech_par     = ech_par_rei;
		pts_pie->i_mvt_uni_dir  = 0;
		pts_pie->c_typ_pie      = 'D';
		pts_pie->c_lib_pie      = 'D';
	}
	else
	{
			/* piece propre camp ou autre */
			pts_hst_pro->i_not = NOT_MIN;
			dir_sui();
			return;
	}
	mvt_pio();
}
/* pour pion camp 1 */

void bas_1_p_1 	(void)
{
	(pts_hst_pro->i_pos_y)-=1;

	if(ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y].i_cam == VIDE)
	{
		/* deplacement simple */
		pts_hst_pro->i_typ_mvt 	= MVT_DEP_SIM;
		dep_sim();
	}
	else
	{
			/* pice propre camp ou autre */
			pts_hst_pro->i_not = NOT_MIN;
			dir_sui();
			return;
	}
	mvt_pio();
}
void bas_2_p_1		(void)
{

	/* restore pice principale */
	/* pouurait tre vit en changeant l'ordre des fct des tpf_mvt_pio */
	if(tpf_res_pie_pri[pts_hst_pro->i_typ_mvt])
	{
		 (*tpf_res_pie_pri[pts_hst_pro->i_typ_mvt]) 	();
	}
	(pts_hst_pro->i_pos_y)-=2;

	if
	(
		ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y].i_cam == VIDE
		&&
		ts_ech[pts_hst_pro->i_pos_x][(pts_hst_pro->i_pos_y)-1].i_cam == VIDE

	)
	{
		/* deplacement simple */
		pts_hst_pro->i_typ_mvt 	= MVT_DEP_SIM;
		dep_sim();
	}
	else
	{
			/* pice propre camp ou autre */
			pts_hst_pro->i_not = NOT_MIN;
			dir_sui();
			return;
	}
	mvt_pio();
}
void bas_gauche_p_1(void)
{
	(pts_hst_pro->i_pos_x)-=1;
	(pts_hst_pro->i_pos_y)-=1;

	if(ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y].i_cam == BLANC)
	{
		/* prise simple  */
		pts_hst_pro->i_typ_mvt 	= MVT_PRI_SIM;
		pri_sim();
	}
	else
	{
			/* pice propre camp ou autre */
			pts_hst_pro->i_not = NOT_MIN;
			dir_sui();
			return;
	}
	mvt_pio();
}
void bas_droite_p_1(void)
{
	(pts_hst_pro->i_pos_x)+=1;
	(pts_hst_pro->i_pos_y)-=1;

	if(ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y].i_cam == BLANC)
	{
		/* prise simple  */
		pts_hst_pro->i_typ_mvt 	= MVT_PRI_SIM;
		pri_sim();
	}
	else
	{
			/* pice propre camp ou autre */
			pts_hst_pro->i_not = NOT_MIN;
			dir_sui();
			return;
	}
	mvt_pio();
}
void bas_gauche_pas_p_1(void)
{
	(pts_hst_pro->i_pos_x)-=1;
	(pts_hst_pro->i_pos_y)-=1;

	if
	(
		(tpts_pie[BLANC]+pts_hst_pro_p->i_Id)->c_typ_pie == 'P'
		&&
		/*  test position de dpart du pion  prendre */
		pts_hst_pro_p->i_pos_ori_x == pts_hst_pro->i_pos_x
		&&
		pts_hst_pro_p->i_pos_ori_y == l2
		&&
		/* test position d'arrive du pion  prendre   */
		pts_hst_pro_p->i_pos_x == pts_hst_pro->i_pos_x
		&&
		pts_hst_pro_p->i_pos_y == l4

	)
	{
		/* prise simple  */
		pts_hst_pro->i_typ_mvt 	= MVT_PRI_PAS;
		pri_pas();
	}
	else
	{
			/* pice propre camp ou autre */
			pts_hst_pro->i_not = NOT_MIN;
			dir_sui();
			return;
	}
	mvt_pio();
}
void bas_droite_pas_p_1(void)
{
	(pts_hst_pro->i_pos_x)+=1;
	(pts_hst_pro->i_pos_y)-=1;

	if
	(
		(tpts_pie[BLANC]+pts_hst_pro_p->i_Id)->c_typ_pie == 'P'
		&&
		/*  test position de dpart du pion  prendre */
		pts_hst_pro_p->i_pos_ori_x == pts_hst_pro->i_pos_x
		&&
		pts_hst_pro_p->i_pos_ori_y == l2
		&&
		/* test position d'arrive du pion  prendre   */
		pts_hst_pro_p->i_pos_x == pts_hst_pro->i_pos_x
		&&
		pts_hst_pro_p->i_pos_y == l4

	)
	{
		/* prise simple  */
		pts_hst_pro->i_typ_mvt 	= MVT_PRI_PAS;
		pri_pas();
	}
	else
	{
			/* pice propre camp ou autre */
			pts_hst_pro->i_not = NOT_MIN;
			dir_sui();
			return;
	}
	mvt_pio();
}
void bas_gauche_cav_p_1(void)
{
	(pts_hst_pro->i_pos_x)-=1;
	(pts_hst_pro->i_pos_y)-=1;

	if(ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y].i_cam == BLANC)
	{
		/* prise simple  */
		pts_hst_pro->i_typ_mvt 	= MVT_PRI_PIO_CAV;
		pri_sim();

		/* transforme le pion en cavalier */
		pts_pie->i_for			= 2;
		pts_pie->pf_ini_hst_mvt = ini_hst_mvt_cav;
		pts_pie->pf_jou         = jou_ctfr;
		pts_pie->pf_ech_par     = ech_par_cav;
		pts_pie->i_mvt_uni_dir  = 1;
		pts_pie->c_typ_pie      = 'C';
		pts_pie->c_lib_pie      = 'c';

	}
	else
	{
			/* piece propre camp ou autre */
			pts_hst_pro->i_not = NOT_MIN;
			dir_sui();
			return;
	}
	mvt_pio();
}
void bas_droite_cav_p_1(void)
{
	(pts_hst_pro->i_pos_x)+=1;
	(pts_hst_pro->i_pos_y)-=1;

	if(ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y].i_cam == BLANC)
	{
		/* prise simple  */
		pts_hst_pro->i_typ_mvt 	= MVT_PRI_PIO_CAV;
		pri_sim();

		/* transforme le pion en cavalier */
		pts_pie->i_for			= 2;
		pts_pie->pf_ini_hst_mvt = ini_hst_mvt_cav;
		pts_pie->pf_jou         = jou_ctfr;
		pts_pie->pf_ech_par     = ech_par_cav;
		pts_pie->i_mvt_uni_dir  = 1;
		pts_pie->c_typ_pie      = 'C';
		pts_pie->c_lib_pie      = 'c';

	}
	else
	{
			/* piece propre camp ou autre */
			pts_hst_pro->i_not = NOT_MIN;
			dir_sui();
			return;
	}
	mvt_pio();
}
void bas_cav_p_1 	(void)
{
	(pts_hst_pro->i_pos_y)-=1;

	if(ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y].i_cam == VIDE)
	{
		/* deplacement simple */
		pts_hst_pro->i_typ_mvt 	= MVT_PIO_CAV;
		dep_sim();

		/* transforme le pion en cavalier */
		pts_pie->i_for			= 2;
		pts_pie->pf_ini_hst_mvt = ini_hst_mvt_cav;
		pts_pie->pf_jou         = jou_ctfr;
		pts_pie->pf_ech_par     = ech_par_cav;
		pts_pie->i_mvt_uni_dir  = 1;
		pts_pie->c_typ_pie      = 'C';
		pts_pie->c_lib_pie      = 'c';
	}
	else
	{
			/* piece propre camp ou autre */
			pts_hst_pro->i_not = NOT_MIN;
			dir_sui();
			return;
	}
	mvt_pio();
}
void bas_gauche_rei_p_1(void)
{
	(pts_hst_pro->i_pos_x)-=1;
	(pts_hst_pro->i_pos_y)-=1;

	if(ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y].i_cam == BLANC)
	{
		/* prise simple  */
		pts_hst_pro->i_typ_mvt 	= MVT_PRI_PIO_REI;
		pri_sim();

		/* transforme le pion en reine  */
		pts_pie->i_for			= 4;
		pts_pie->pf_ini_hst_mvt = ini_hst_mvt_rei;
		pts_pie->pf_jou         = jou_ctfr;
		pts_pie->pf_ech_par     = ech_par_rei;
		pts_pie->i_mvt_uni_dir  = 0;
		pts_pie->c_typ_pie      = 'D';
		pts_pie->c_lib_pie      = 'd';

	}
	else
	{
			/* piece propre camp ou autre */
			pts_hst_pro->i_not = NOT_MIN;
			dir_sui();
			return;
	}
	mvt_pio();
}
void bas_droite_rei_p_1(void)
{
	(pts_hst_pro->i_pos_x)+=1;
	(pts_hst_pro->i_pos_y)-=1;

	if(ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y].i_cam == BLANC)
	{
		/* prise simple  */
		pts_hst_pro->i_typ_mvt 	= MVT_PRI_PIO_REI;
		pri_sim();

		/* transforme le pion en reine  */
		pts_pie->i_for			= 4;
		pts_pie->pf_ini_hst_mvt = ini_hst_mvt_rei;
		pts_pie->pf_jou         = jou_ctfr;
		pts_pie->pf_ech_par     = ech_par_rei;
		pts_pie->i_mvt_uni_dir  = 0;
		pts_pie->c_typ_pie      = 'D';
		pts_pie->c_lib_pie      = 'd';
	}
	else
	{
			/* piece propre camp ou autre */
			pts_hst_pro->i_not = NOT_MIN;
			dir_sui();
			return;
	}
	mvt_pio();
}
void bas_rei_p_1 	(void)
{

	(pts_hst_pro->i_pos_y)-=1;

	if(ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y].i_cam == VIDE)
	{
		/* deplacement simple */
		pts_hst_pro->i_typ_mvt 	= MVT_PIO_REI;
		dep_sim();

		/* transforme le pion en reine  */
		pts_pie->i_for			= 4;
		pts_pie->pf_ini_hst_mvt = ini_hst_mvt_rei;
		pts_pie->pf_jou         = jou_ctfr;
		pts_pie->pf_ech_par     = ech_par_rei;
		pts_pie->i_mvt_uni_dir  = 0;
		pts_pie->c_typ_pie      = 'D';
		pts_pie->c_lib_pie      = 'd';
	}
	else
	{
			/* piece propre camp ou autre */
			pts_hst_pro->i_not = NOT_MIN;
			dir_sui();
			return;
	}
	mvt_pio();
}
void mvt_pio 		(void)
{

	/* echec pro precedente ?*/
	if (pts_hst_pro_p->i_ech==1)
	{
		/* verife  nouveau echec */
		/* 		par pice principale pro precedente ? */
		/* 	ou	par pice secondaire pro precedente ? */
		/* 	ou  par demasquage pro precedente ? */
		/* 	ou  par demasquage prof actuelle */

		if
		(
			(
				tpf_cas_ctl_sta[pts_hst_pro_p->i_ech_dir_pri]
				&&
				(*tpf_cas_ctl_sta[pts_hst_pro_p->i_ech_dir_pri])
									(pts_hst_pro->i_pos_x_R_p_c,
									 pts_hst_pro->i_pos_y_R_p_c,
									 pts_hst_pro->i_cam_adv)
			)
		||
			(
				tpf_cas_ctl_sta[pts_hst_pro_p->i_ech_dir_dem]
				&&
				(*tpf_cas_ctl_sta[pts_hst_pro_p->i_ech_dir_dem])
									(pts_hst_pro->i_pos_x_R_p_c,
									 pts_hst_pro->i_pos_y_R_p_c,
									 pts_hst_pro->i_cam_adv)
			)
		||
			(
				tpf_cas_ctl_sta[pts_hst_pro->i_ech_dir_dem_p_c]
				&&
				(*tpf_cas_ctl_sta[pts_hst_pro->i_ech_dir_dem_p_c])
									(pts_hst_pro->i_pos_x_R_p_c,
									 pts_hst_pro->i_pos_y_R_p_c,
									 pts_hst_pro->i_cam_adv)
			)
		)

		{
			/* echec donc mvt impossible */
			pts_hst_pro->i_not = NOT_MIN;
			dir_sui();
			return;
		}
		else	/* roi n'est plus echec  */
		{
			/* roi n'est plus echec donc mat = N  */
			pts_hst_pro_p->i_mat = 0;

		}

	}
	else  	/* pas d'echec prof precedente */
	{
		/* Verifie echec propre camp par demasquage  */
		if
		(
			tpf_cas_ctl_sta[pts_hst_pro->i_ech_dir_dem_p_c]
			&&
			(*tpf_cas_ctl_sta[pts_hst_pro->i_ech_dir_dem_p_c])
									(pts_hst_pro->i_pos_x_R_p_c,
									 pts_hst_pro->i_pos_y_R_p_c,
									 pts_hst_pro->i_cam_adv)
		)

		{
			/* echec donc mvt impossible */
			pts_hst_pro->i_not = NOT_MIN;
			dir_sui();
			return;
		}
		else     /* pas d'echec */
		{

			/* roi ne se retrouve pas echec donc pat = N  */
			pts_hst_pro_p->i_pat = 0;

		}
	}
	if
	(
	i_pro_sim_act<i_pro_sim_max_sup
	||
	(
	ti_typ_mvt_pri[pts_hst_pro->i_typ_mvt]
	&&
	i_pro_sim_act<i_pro_sim_max_inf
	)
	)

	{
		/* verifie si cause echec camp adverse */
		/* par mvt pice principale ou par demasquage*/
		if
		(
			(*pts_pie->pf_ech_par)
						(pts_hst_pro->i_pos_x,
						 pts_hst_pro->i_pos_y,
						 &(pts_hst_pro->i_ech_dir_pri))
			||
			(
				tpf_cas_ctl_sta[pts_hst_pro->i_ech_dir_dem]
				&&
				(*tpf_cas_ctl_sta[pts_hst_pro->i_ech_dir_dem])
									(pts_hst_pro->i_pos_x_R_c_a,
									 pts_hst_pro->i_pos_y_R_c_a,
									 pts_hst_pro->i_cam)
			)
		)
		{
		   pts_hst_pro->i_ech=1;
		   pts_hst_pro->i_mat=1;
		   pts_hst_pro->i_pat=0;

		}
		else
		{
		   pts_hst_pro->i_ech=0;
		   pts_hst_pro->i_mat=0;
		   pts_hst_pro->i_pat=1;
		}


		/* descendre ds l'arborescence */
		pro_sui();

		/* recopie valeur grd et petit rock pour cam propre */
		cop_val_prc_pc();
		cop_val_grc_pc();

		/* recopie valeur grd et petit rock pour cam adverse */

		cop_val_prc_ca();
		cop_val_grc_ca();


	}
	else
	{

		/* mise  jour note max */
		if(pts_hst_pro->i_not>pts_hst_pro->i_not_max)
			pts_hst_pro->i_not_max =pts_hst_pro->i_not;

		/* direction suivante mme pro */
		dir_sui();
		return;
	}

}

/* Intialisation hst_pro */
void pro_sui 	(void)
{
	i_pro_sim_act++;

	/* initialisation du  pionteurs sur hst */
	pts_hst_pro = &ts_hst_pro[i_pro_sim_act];
	pts_hst_pro_p = &ts_hst_pro[i_pro_sim_act-1];

	/* initialisation hst avec pos roi camp propre et adverse */
	hst_pos_roi();

	/* initialisation du  pionteurs piece actuelle sur 0 */
	pts_pie =
	tpts_pie[pts_hst_pro->i_cam];

	/* initialisation du  pionteurs piece suivante   */
	pts_pie_sui =
	tpts_pie[pts_hst_pro->i_cam]+pts_pie->i_pie_sui;

	/* chargement historique  avec pice */
	pts_hst_pro->i_Id= pts_pie->i_pie_sui;
	pts_hst_pro->i_pos_x		= pts_pie_sui->i_pos_x;
	pts_hst_pro->i_pos_y		= pts_pie_sui->i_pos_y;
	pts_hst_pro->i_pos_ori_x	= pts_pie_sui->i_pos_x;
	pts_hst_pro->i_pos_ori_y	= pts_pie_sui->i_pos_y;
	pts_hst_pro->i_dir_sui  	= pts_pie_sui->i_mvt_uni_dir;

	/* empche execution restore pice secondaire
 */
	pts_hst_pro->i_typ_mvt   	= MVT_DEP_SIM;  /* pas de pice secondaire */

	/* initialisation du  pionteurs piece actuelle  */
	pts_pie =
/*	tpts_pie[pts_hst_pro->i_cam]+pts_hst_pro->i_Id;*/
	pts_pie+pts_hst_pro->i_Id;

	/* initialisation pointeur sur fct mvt ds hst */
	(*pts_pie->pf_ini_hst_mvt)();
	/* raz not_max */
	pts_hst_pro->i_not_max			= NOT_MIN;


	/* calcul echec par demasquage sur roi camp adverse */
	ech_cal_dir_dem  (	pts_hst_pro->i_cam_adv,
						&(pts_hst_pro->i_ech_dir_dem));
	/* optimisation/bug
que se passe-t-il si la piece en cours est le roi */
	/* calcul echec par demasquage sur roi propre camp   */
	ech_cal_dir_dem  (	pts_hst_pro->i_cam,
						&(pts_hst_pro->i_ech_dir_dem_p_c));
	return;
}
/* initialisation hst avec pointeur sur tableau de fct mvt */
void ini_hst_mvt_roi(void)
{
	pts_hst_pro->ptpf_mvt=
	ptpf_mvt_roi[pts_hst_pro->i_pos_ori_x][pts_hst_pro->i_pos_ori_y];
}
void ini_hst_mvt_rei(void)
{
	pts_hst_pro->ptpf_mvt=
	ptpf_mvt_rei[pts_hst_pro->i_pos_ori_x][pts_hst_pro->i_pos_ori_y];

}
void ini_hst_mvt_fou(void)
{
	pts_hst_pro->ptpf_mvt=
	ptpf_mvt_fou[pts_hst_pro->i_pos_ori_x][pts_hst_pro->i_pos_ori_y];

}
void ini_hst_mvt_tou(void)
{
	pts_hst_pro->ptpf_mvt=
	ptpf_mvt_tou[pts_hst_pro->i_pos_ori_x][pts_hst_pro->i_pos_ori_y];

}
void ini_hst_mvt_cav(void)
{
	pts_hst_pro->ptpf_mvt=
	ptpf_mvt_cav[pts_hst_pro->i_pos_ori_x][pts_hst_pro->i_pos_ori_y];
}
void ini_hst_mvt_pio_0(void)
{
	pts_hst_pro->ptpf_mvt=
	ptpf_mvt_pio_0[pts_hst_pro->i_pos_ori_x][pts_hst_pro->i_pos_ori_y];
}
void ini_hst_mvt_pio_1(void)
{
	pts_hst_pro->ptpf_mvt=
	ptpf_mvt_pio_1[pts_hst_pro->i_pos_ori_x][pts_hst_pro->i_pos_ori_y];
}

/* Direction suivante */
void dir_sui 	(void)
{
			/* restore la position d'origine */
			pts_hst_pro->i_pos_x = pts_hst_pro->i_pos_ori_x;
			pts_hst_pro->i_pos_y = pts_hst_pro->i_pos_ori_y;
			/* direction suivante */
			pts_hst_pro->ptpf_mvt++;

}

/* Recherche de la pice suivante */
/* dir_sui pas executer si plusieurs mvt par dir */
void pie_sui 	(void)
{

	/* restore pice principale */
	if(tpf_res_pie_pri[pts_hst_pro->i_typ_mvt])
	{
		 (*tpf_res_pie_pri[pts_hst_pro->i_typ_mvt]) 	();
	}

	/* si dernire pice */
	if  (pts_pie->i_pie_sui == 17)
	{
		/* calcule de la note   */
		if(pts_hst_pro_p->i_mat)
		{
			pts_hst_pro_p->i_not += 10;
			ts_not_mvt_ini[i_not_cpt_mvt_ini].
				ti_nbr_mat[pts_hst_pro_p->i_cam]++;
		}

		else
		{
			if(pts_hst_pro_p->i_pat)
			{
				pts_hst_pro_p->i_not =0;
				ts_not_mvt_ini[i_not_cpt_mvt_ini].
					ti_nbr_pat[pts_hst_pro_p->i_cam]++;
			}
			else
			pts_hst_pro_p->i_not -=	pts_hst_pro->i_not_max;

		}

		if(pts_hst_pro_p->i_not > pts_hst_pro_p->i_not_max)
				pts_hst_pro_p->i_not_max =pts_hst_pro_p->i_not;

		if (i_pro_sim_act == i_pro_act+1)
		{
			/* fin de simulation  */
			i_sim_end = 1;
			return;
		}
		else
		{
		/* calcul de la note pour pro =1 */
		if (i_pro_sim_act == i_pro_act+2)
		{
			not_cal();
		}

		i_pro_sim_act--;

		/* initialisation du  pionteurs sur hst */
		pts_hst_pro 	= &ts_hst_pro[i_pro_sim_act];
		pts_hst_pro_p 	= &ts_hst_pro[i_pro_sim_act-1];

		/* initialisation du  pionteurs piece actuelle  */
		pts_pie = tpts_pie[pts_hst_pro->i_cam]+pts_hst_pro->i_Id;

		/* direction suivante seulement pour pice ayant un mvt par dir */
		if(pts_hst_pro->i_dir_sui)		dir_sui();

		/* interruption de la simulation sur demande */
		/*if (i_pro_sim_act == i_pro_sim_int_cla)
		{
			sto_sim();
		}
*/


		}
	}
	else    /* si pas derniere piece */
	{

		/* chargement historique avec pice suivante */
		pts_hst_pro->i_Id			= pts_pie->i_pie_sui;
		/* initialisation du pionteurs piece */
		pts_pie =
			tpts_pie[pts_hst_pro->i_cam]+pts_pie->i_pie_sui;

		pts_hst_pro->i_pos_x		= pts_pie->i_pos_x;
		pts_hst_pro->i_pos_y		= pts_pie->i_pos_y;
		pts_hst_pro->i_pos_ori_x	= pts_pie->i_pos_x;
		pts_hst_pro->i_pos_ori_y	= pts_pie->i_pos_y;
		pts_hst_pro->i_dir_sui  	= pts_pie->i_mvt_uni_dir;

		/* initialisation pointeur sur fct mvt ds hst */
		(*pts_pie->pf_ini_hst_mvt)();

		/* calcul echec par demasquage sur roi camp adverse */
		ech_cal_dir_dem  (	pts_hst_pro->i_cam_adv,
							&(pts_hst_pro->i_ech_dir_dem));
		/* calcul echec par demasquage sur roi propre camp   */
		ech_cal_dir_dem  (	pts_hst_pro->i_cam,
							&(pts_hst_pro->i_ech_dir_dem_p_c));

	}


}

/* Copie val petit/grand rock  pour propre camp */
void cop_val_prc_pc (void)
{
		pts_hst_pro->
		ti_roc_cam_typ[pts_hst_pro_p->i_cam][PET_ROC]=
		pts_hst_pro_p->
		ti_roc_cam_typ[pts_hst_pro_p->i_cam][PET_ROC];

}
void cop_val_grc_pc (void)
{
		pts_hst_pro->
		ti_roc_cam_typ[pts_hst_pro_p->i_cam][GRA_ROC]=
		pts_hst_pro_p->
		ti_roc_cam_typ[pts_hst_pro_p->i_cam][GRA_ROC] ;

}

/* Copie val petit/grand rock  camp adverse */
void cop_val_prc_ca (void)
{
		pts_hst_pro->
		ti_roc_cam_typ[pts_hst_pro_p->i_cam_adv][PET_ROC]=
		pts_hst_pro_p->
		ti_roc_cam_typ[pts_hst_pro_p->i_cam_adv][PET_ROC];

}
void cop_val_grc_ca (void)
{
		pts_hst_pro->
		ti_roc_cam_typ[pts_hst_pro_p->i_cam_adv][GRA_ROC]=
		pts_hst_pro_p->
		ti_roc_cam_typ[pts_hst_pro_p->i_cam_adv][GRA_ROC] ;

}
/* chargement hst avec position roi camp propre et adverse  */
void hst_pos_roi 	(void)
{
	/* initialisation du ptr et memorisation position roi propre camp */
	pts_pie_roi_p_c =
		tpts_pie[pts_hst_pro->i_cam]+Id_roi[pts_hst_pro->i_cam];

	pts_hst_pro->i_pos_x_R_p_c	= pts_pie_roi_p_c->i_pos_x;
	pts_hst_pro->i_pos_y_R_p_c	= pts_pie_roi_p_c->i_pos_y;

	/* initialisation du ptr et memorisation position roi camp adverse */
	pts_pie_roi_c_a =
		tpts_pie[pts_hst_pro->i_cam_adv]+Id_roi[pts_hst_pro->i_cam_adv];

	pts_hst_pro->i_pos_x_R_c_a	= pts_pie_roi_c_a->i_pos_x;
	pts_hst_pro->i_pos_y_R_c_a	= pts_pie_roi_c_a->i_pos_y;


}


/* fonction de deplacement simple pice(s) */
void dep_sim()
{
	/* suprime pice de son emplacement dans echiquier */
	ts_ech[pts_pie ->i_pos_x][pts_pie ->i_pos_y].i_cam 	= VIDE;
	ts_ech[pts_pie ->i_pos_x][pts_pie ->i_pos_y].i_Id 	= VIDE;

	/* modifie place dans pice */
	pts_pie ->i_pos_x= pts_hst_pro->i_pos_x;
	pts_pie ->i_pos_y= pts_hst_pro->i_pos_y;

	/* ajoute  sa nouvelle place dans echiquier */
	ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y].i_cam = pts_hst_pro->i_cam;
	ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y].i_Id = pts_hst_pro->i_Id;

	/* maj note dans hst */
	pts_hst_pro->i_not = 0;

}
/* fontion de deplacement avec simple prise de pices */
/* optimisation certains pointeur inutiles */

void pri_sim()
{
	/* suprime pice principale de son anciene place dans echiquier */
	ts_ech[pts_pie ->i_pos_x][pts_pie ->i_pos_y].i_cam 	= VIDE;
	ts_ech[pts_pie ->i_pos_x][pts_pie ->i_pos_y].i_Id 	= VIDE;

	/* modifie sa place dans piece */
	pts_pie ->i_pos_x= pts_hst_pro->i_pos_x;
	pts_pie ->i_pos_y= pts_hst_pro->i_pos_y;

	 /* memorisation Id de la piece prise */
	pts_hst_pro->i_Id_2p =
		 ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y].i_Id;

	/* ajoute  sa nouvelle place dans echiquier (pice prise efface) */
	ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y].i_cam = pts_hst_pro->i_cam;
	ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y].i_Id = pts_hst_pro->i_Id;

	/* initailisation des pionteurs sur pie */
	/* piece prise */
	pts_pie_pri 	= tpts_pie[pts_hst_pro->i_cam_adv]+pts_hst_pro->i_Id_2p;
	pts_pie_sui_pri = tpts_pie[pts_hst_pro->i_cam_adv]+pts_pie_pri->i_pie_sui;
	pts_pie_pre_pri = tpts_pie[pts_hst_pro->i_cam_adv]+pts_pie_pri->i_pie_pre;

	/* suppression piece prise dans pice */
	pts_pie_pre_pri->i_pie_sui = pts_pie_pri->i_pie_sui;
	pts_pie_sui_pri->i_pie_pre = pts_pie_pri->i_pie_pre;

	/* maj note dans hst */
	pts_hst_pro->i_not = pts_pie_pri->i_for ;



}
void pri_pas()
{
	/* suprime pice principale de son anciene place dans echiquier */
	ts_ech[pts_pie ->i_pos_x][pts_pie ->i_pos_y].i_cam = VIDE;
	ts_ech[pts_pie ->i_pos_x][pts_pie ->i_pos_y].i_Id  = VIDE;

	/* modifie sa place dans piece */
	pts_pie ->i_pos_x= pts_hst_pro->i_pos_x;
	pts_pie ->i_pos_y= pts_hst_pro->i_pos_y;

	 /* memorisation Id de la piece prise */
	pts_hst_pro->i_Id_2p =
		 ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_ori_y].i_Id;

	/* ajoute a sa nouvelle place dans echiquier (piece prise a effacer) */
	ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y].i_cam = pts_hst_pro->i_cam;
	ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y].i_Id = pts_hst_pro->i_Id;

	
	/* supprime le piece prise de l'echiquier (necessaire dans prise en passant) */
	ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_ori_y].i_cam = VIDE;
	ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_ori_y].i_Id  = VIDE;

	/* initailisation des pionteurs sur pie */
	/* piece prise */
	pts_pie_pri 	= tpts_pie[pts_hst_pro->i_cam_adv]+pts_hst_pro->i_Id_2p;
	pts_pie_sui_pri = tpts_pie[pts_hst_pro->i_cam_adv]+pts_pie_pri->i_pie_sui;
	pts_pie_pre_pri = tpts_pie[pts_hst_pro->i_cam_adv]+pts_pie_pri->i_pie_pre;

	/* suppression pice prise dans pice */
	pts_pie_pre_pri->i_pie_sui = pts_pie_pri->i_pie_sui;
	pts_pie_sui_pri->i_pie_pre = pts_pie_pri->i_pie_pre;

	/* maj note dans hst */
	pts_hst_pro->i_not = pts_pie_pri->i_for ;



}
/* fonction de deplacement grand rock blanc */
void dep_grd_roc_0()
{
	/* suprime roi blanc de son emplacement dans echiquier */
/*	ts_ech[6][2].i_cam = -1;
	ts_ech[6][2].i_Id  = -1;*/
	ts_ech[pts_pie->i_pos_x][pts_pie->i_pos_y].i_cam = -1;
	ts_ech[pts_pie->i_pos_x][pts_pie->i_pos_y].i_Id  = -1;

	/* modifie place dans pice */
	pts_pie ->i_pos_x= 4;
	pts_pie ->i_pos_y= 2;

	/* ajoute  sa nouvelle place dans echiquier */
	ts_ech[4][2].i_cam = 0;
	ts_ech[4][2].i_Id = pts_hst_pro->i_Id;

	 /* memorisation Id de la tour grd rock */
	pts_hst_pro->i_Id_2p = ts_ech[2][2].i_Id;

	/* suprime tour de son emplacement dans echiquier */
	ts_ech[2][2].i_cam = -1;
	ts_ech[2][2].i_Id  = -1;
	/* modifie place dans pice */
	pts_pie_tou_roc = ts_pie_0 +pts_hst_pro->i_Id_2p;
	pts_pie_tou_roc->i_pos_x= 5;
	pts_pie_tou_roc->i_pos_y= 2;

	/* ajoute  sa nouvelle place dans echiquier */
	ts_ech[5][2].i_cam = 0;
	ts_ech[5][2].i_Id = pts_hst_pro->i_Id_2p;

	/* maj note dans hst */
	pts_hst_pro->i_not = 0;

}
/* fonction de deplacement grand rock noir */
void dep_grd_roc_1()
{
	/* suprime roi blanc de son emplacement dans echiquier */
	ts_ech[pts_pie->i_pos_x][pts_pie->i_pos_y].i_cam = -1;
	ts_ech[pts_pie->i_pos_x][pts_pie->i_pos_y].i_Id  = -1;

	/* modifie place dans pice */
	pts_pie ->i_pos_x= 4;
	pts_pie ->i_pos_y= 9;

	/* ajoute  sa nouvelle place dans echiquier */
	ts_ech[4][9].i_cam = 1;
	ts_ech[4][9].i_Id = pts_hst_pro->i_Id;

	 /* memorisation Id de la tour grd rock */
	pts_hst_pro->i_Id_2p = ts_ech[2][9].i_Id;

	/* suprime tour de son emplacement dans echiquier */
	ts_ech[2][9].i_cam = -1;
	ts_ech[2][9].i_Id  = -1;

	/* modifie place dans pice */
	pts_pie_tou_roc = ts_pie_1 +pts_hst_pro->i_Id_2p;
	pts_pie_tou_roc->i_pos_x= 5;
	pts_pie_tou_roc->i_pos_y= 9;

	/* ajoute  sa nouvelle place dans echiquier */
	ts_ech[5][9].i_cam = 1;
	ts_ech[5][9].i_Id = pts_hst_pro->i_Id_2p;

	/* maj note dans hst */
	pts_hst_pro->i_not = 0;

}
/* fonction de deplacement petit rock blanc */
void dep_pet_roc_0()
{
	/* suprime roi blanc de son emplacement dans echiquier */
	ts_ech[pts_pie->i_pos_x][pts_pie->i_pos_y].i_cam = -1;
	ts_ech[pts_pie->i_pos_x][pts_pie->i_pos_y].i_Id  = -1;

	/* modifie place dans pice */
	pts_pie ->i_pos_x= 8;
	pts_pie ->i_pos_y= 2;

	/* ajoute  sa nouvelle place dans echiquier */
	ts_ech[8][2].i_cam = 0;
	ts_ech[8][2].i_Id = pts_hst_pro->i_Id;

	 /* memorisation Id de la tour petit rock */
	pts_hst_pro->i_Id_2p = ts_ech[9][2].i_Id;

	/* suprime tour de son emplacement dans echiquier */
	ts_ech[9][2].i_cam = -1;
	ts_ech[9][2].i_Id  = -1;
	/* modifie place dans pice */
	pts_pie_tou_roc = ts_pie_0 +pts_hst_pro->i_Id_2p;
	pts_pie_tou_roc->i_pos_x= 7;
	pts_pie_tou_roc->i_pos_y= 2;

	/* ajoute  sa nouvelle place dans echiquier */
	ts_ech[7][2].i_cam = 0;
	ts_ech[7][2].i_Id = pts_hst_pro->i_Id_2p;

	/* maj note dans hst */
	pts_hst_pro->i_not = 0;

}
/* fonction de deplacement petit rock noir */
void dep_pet_roc_1()
{
	/* suprime roi blanc de son emplacement dans echiquier */
	ts_ech[pts_pie->i_pos_x][pts_pie->i_pos_y].i_cam = -1;
	ts_ech[pts_pie->i_pos_x][pts_pie->i_pos_y].i_Id  = -1;

	/* modifie place dans pice */
	pts_pie ->i_pos_x= 8;
	pts_pie ->i_pos_y= 9;

	/* ajoute  sa nouvelle place dans echiquier */
	ts_ech[8][9].i_cam = 1;
	ts_ech[8][9].i_Id = pts_hst_pro->i_Id;

	 /* memorisation Id de la tour petit rock */
	pts_hst_pro->i_Id_2p = ts_ech[9][9].i_Id;

	/* suprime tour de son emplacement dans echiquier */
	ts_ech[9][9].i_cam = -1;
	ts_ech[9][9].i_Id  = -1;

	/* modifie place dans pice */
	pts_pie_tou_roc = ts_pie_1 +pts_hst_pro->i_Id_2p;
	pts_pie_tou_roc->i_pos_x= 7;
	pts_pie_tou_roc->i_pos_y= 9;

	/* ajoute  sa nouvelle place dans echiquier */
	ts_ech[7][9].i_cam = 1;
	ts_ech[7][9].i_Id = pts_hst_pro->i_Id_2p;

	/* maj note dans hst */
	pts_hst_pro->i_not = 0;

}

/* fontion de restauration pice principale position d'origine */
void pie_pri_res()
{

	/* suprime piece de son emplacement actuel dans echiquier */
	ts_ech[pts_pie ->i_pos_x][pts_pie ->i_pos_y].i_cam = -1;
	ts_ech[pts_pie ->i_pos_x][pts_pie ->i_pos_y].i_Id = -1;

	/* modifie place dans piece */
	pts_pie ->i_pos_x= pts_hst_pro->i_pos_ori_x;
	pts_pie ->i_pos_y= pts_hst_pro->i_pos_ori_y;

	/* remet a son ancienne place dans echiquier */
	/* tst */
	/* printf("\npos origine ds pie_pri_res():%i %i",pts_hst_pro->i_pos_ori_x,pts_hst_pro->i_pos_ori_y);*/
	ts_ech[pts_hst_pro->i_pos_ori_x][pts_hst_pro->i_pos_ori_y].i_cam
		= pts_hst_pro->i_cam;
	ts_ech[pts_hst_pro->i_pos_ori_x][pts_hst_pro->i_pos_ori_y].i_Id
		= pts_hst_pro->i_Id;
}
/* fontion de restauration position d'origine roi petit rock */
/* semble inutil */
/* bug ! interverti petit et grand rock */
void roi_pet_roc_res()
{
	if (pts_hst_pro->i_cam == BLANC) 			/* blanc */
	{
		/* suprime pice de son emplacement dans echiquier */
		ts_ech[8][2].i_cam = -1;
		ts_ech[8][2].i_Id  = -1;

		/* modifie place dans pice */
		pts_pie ->i_pos_x= 6;
		pts_pie ->i_pos_y= 2;

		/* ajoute  sa nouvelle place dans echiquier */
		ts_ech[6][2].i_cam  	= pts_hst_pro->i_cam;
		ts_ech[6][2].i_Id     = pts_hst_pro->i_Id;

	}
	else										/* noir */
	{
		/* suprime pice de son emplacement dans echiquier */
		ts_ech[8][9].i_cam = -1;
		ts_ech[8][9].i_Id  = -1;

		/* modifie place dans pice */
		pts_pie ->i_pos_x= 6;
		pts_pie ->i_pos_y= 9;

		/* ajoute  sa nouvelle place dans echiquier */
		ts_ech[6][9].i_cam  	= pts_hst_pro->i_cam;
		ts_ech[6][9].i_Id     = pts_hst_pro->i_Id;


	}
}
/* fontion de restauration position d'origine roi grand rock */
/* semble inutil */
void roi_grd_roc_res()
{
	if (pts_hst_pro->i_cam == BLANC) 			/* blanc */
	{
		/* suprime pice de son emplacement dans echiquier */
		ts_ech[4][2].i_cam = -1;
		ts_ech[4][2].i_Id  = -1;

		/* modifie place dans pice */
		pts_pie ->i_pos_x= 6;
		pts_pie ->i_pos_y= 2;

		/* ajoute  sa nouvelle place dans echiquier */
		ts_ech[6][2].i_cam    = pts_hst_pro->i_cam;
		ts_ech[6][2].i_Id     = pts_hst_pro->i_Id;

	}
	else										/* noir */
	{
		/* suprime pice de son emplacement dans echiquier */
		ts_ech[4][9].i_cam = -1;
		ts_ech[4][9].i_Id  = -1;

		/* modifie place dans pice */
		pts_pie ->i_pos_x= 6;
		pts_pie ->i_pos_y= 9;

		/* ajoute  sa nouvelle place dans echiquier */
		ts_ech[6][9].i_cam    = pts_hst_pro->i_cam;
		ts_ech[6][9].i_Id     = pts_hst_pro->i_Id;


	}
}

/* fontion de restauration deuxime pice */
/* optimisation certains pointeur inutiles */

/* restore le type de la piece en pion  */
void pio_res()
{
/*
	printf("tst  pio_res");
*/	pts_pie->i_for  		= 1;
	pts_pie->i_mvt_uni_dir	= 1;
	pts_pie->c_typ_pie	= 'P';
	if (pts_hst_pro->i_cam == BLANC)
	{
	pts_pie->pf_ini_hst_mvt	= ini_hst_mvt_pio_0;
	pts_pie->pf_jou 		= jou_pio_0;
	pts_pie->pf_ech_par		= ech_par_pio_0;
	pts_pie->c_lib_pie		= 'P';
	}
	else
	{
	pts_pie->pf_ini_hst_mvt	= ini_hst_mvt_pio_1;
	pts_pie->pf_jou 		= jou_pio_1;
	pts_pie->pf_ech_par		= ech_par_pio_1;
	pts_pie->c_lib_pie		= 'p';
	}
}
/* prise de pice par pion avec trnasformation en autre pice */
void pri_pio_res()
{
	pio_res();
	pie_sup_res();
}
/* prise de de piece  */
void pie_sup_res()
{
	pie_pri_res();
	/* initailisation des pionteurs sur pie */
	/* piece prise */
	pts_pie_pri 	= tpts_pie[pts_hst_pro->i_cam_adv]+pts_hst_pro->i_Id_2p;
	pts_pie_sui_pri = tpts_pie[pts_hst_pro->i_cam_adv]+pts_pie_pri->i_pie_sui;
	pts_pie_pre_pri = tpts_pie[pts_hst_pro->i_cam_adv]+pts_pie_pri->i_pie_pre;

	/* desuppression piece prise dans piece */
	pts_pie_pre_pri->i_pie_sui = pts_hst_pro->i_Id_2p;
	pts_pie_sui_pri->i_pie_pre = pts_hst_pro->i_Id_2p;

	/* ajoute a son ancienne place dans echiquier */
	ts_ech[pts_pie_pri->i_pos_x][pts_pie_pri->i_pos_y].i_cam
	= pts_hst_pro->i_cam_adv;

	ts_ech[pts_pie_pri->i_pos_x][pts_pie_pri->i_pos_y].i_Id =
	pts_hst_pro->i_Id_2p;
}
/* tour grand rock */
void tou_grd_roc_res()
{
   	/*utile seulement si prise de pice ?*/
	/* roi_grd_roc_res(); */
	if (pts_hst_pro->i_cam == BLANC)     			/* blanc */
	{
	/* initailisation du pionteurs sur tour */
	pts_pie_tou_roc 	= ts_pie_0+pts_hst_pro->i_Id_2p;

	/* suprime tour de son emplacement dans echiquier */
	ts_ech[5][2].i_cam = -1;
	ts_ech[5][2].i_Id = -1;

	/* modifie place dans pice */
	pts_pie_tou_roc->i_pos_x= 2 ;
	pts_pie_tou_roc->i_pos_y= 2 ;

	/* ajoute  sa nouvelle place dans echiquier */
	ts_ech[2][2].i_cam  	= pts_hst_pro->i_cam;
	ts_ech[2][2].i_Id    	= pts_hst_pro->i_Id_2p;
	}
	else									/* noir */
	{
	/* initailisation du pionteurs sur tour */
	pts_pie_tou_roc 	= ts_pie_1+pts_hst_pro->i_Id_2p;

	/* suprime pice de son emplacement dans echiquier */
	ts_ech[5][9].i_cam = -1;
	ts_ech[5][9].i_Id = -1;

	/* modifie place dans pice */
	pts_pie_tou_roc->i_pos_x= 2 ;
	pts_pie_tou_roc->i_pos_y= 9 ;

	/* ajoute  sa nouvelle place dans echiquier */
	ts_ech[2][9].i_cam  	= pts_hst_pro->i_cam;
	ts_ech[2][9].i_Id    	= pts_hst_pro->i_Id_2p;
	}

}
/* tour petit rock */
void tou_pet_roc_res()
{
 	/* utile seulement si prise de pice ? */ 	
	/* roi_pet_roc_res(); */
	
	if (pts_hst_pro->i_cam == BLANC)     			/* blanc */
	{
	/* initailisation du pionteurs sur tour */
	pts_pie_tou_roc 	= ts_pie_0+pts_hst_pro->i_Id_2p;

	/* suprime tour de son emplacement dans echiquier */
	ts_ech[7][2].i_cam = -1;
	ts_ech[7][2].i_Id = -1;

	/* modifie place dans pice */
	pts_pie_tou_roc->i_pos_x= 9 ;
	pts_pie_tou_roc->i_pos_y= 2 ;

	/* ajoute  sa nouvelle place dans echiquier */
	ts_ech[9][2].i_cam  	= pts_hst_pro->i_cam;
	ts_ech[9][2].i_Id    	= pts_hst_pro->i_Id_2p;
	}
	else									/* noir */
	{
	/* initailisation du pionteurs sur tour */
	pts_pie_tou_roc 	= ts_pie_1+pts_hst_pro->i_Id_2p;

	/* suprime pice de son emplacement dans echiquier */
	ts_ech[7][9].i_cam = -1;
	ts_ech[7][9].i_Id = -1;

	/* modifie place dans pice */
	pts_pie_tou_roc->i_pos_x= 9 ;
	pts_pie_tou_roc->i_pos_y= 9 ;

	/* ajoute  sa nouvelle place dans echiquier */
	ts_ech[9][9].i_cam  	= pts_hst_pro->i_cam;
	ts_ech[9][9].i_Id    	= pts_hst_pro->i_Id_2p;
	}

}

/*****************************************************************************/
/* calcul et mmorisation de la note du mvt initial */
/*****************************************************************************/
void not_cal (void)
{
	struct st_pie *pts_pie_cal;		/* ptr tableau structpice */
	int i_pro_cpt;
	int i_tst;
	printf("\nmvt num:%i cpt:%li",i_not_cpt_mvt_ini,cpt);
	/* tst */
	/* aff_ech(BLANC);
	
	i_tst=getchar();*/
	/* memorise l'Id */
	ts_not_mvt_ini[i_not_cpt_mvt_ini].i_Id =
						pts_hst_pro_p->i_Id;
	/* memorise le type du mouvement */
	ts_not_mvt_ini[i_not_cpt_mvt_ini].i_typ_mvt =
						pts_hst_pro_p->i_typ_mvt;
	/* memorise la position de depart */

	ts_not_mvt_ini[i_not_cpt_mvt_ini].i_pos_ori_x =
		pts_hst_pro_p->i_pos_ori_x;
	ts_not_mvt_ini[i_not_cpt_mvt_ini].i_pos_ori_y =
		pts_hst_pro_p->i_pos_ori_y;

	/* memorise la position d'arrive */
	ts_not_mvt_ini[i_not_cpt_mvt_ini].i_pos_arr_x =
		pts_hst_pro_p->i_pos_x;
	ts_not_mvt_ini[i_not_cpt_mvt_ini].i_pos_arr_y =
		pts_hst_pro_p->i_pos_y;
	/* initailisation des pionteurs sur  pie */
	pts_pie_cal =
		tpts_pie[pts_hst_pro_p->i_cam]+pts_hst_pro_p->i_Id;

	/* memorise le libelle */
	ts_not_mvt_ini[i_not_cpt_mvt_ini].c_lib_pie =
		pts_pie_cal->c_lib_pie;

	/* memorise et raz de la note  */
	ts_not_mvt_ini[i_not_cpt_mvt_ini].i_not_mvt_ini =
			pts_hst_pro_p->i_not ;
	/* increment du compteur de mouvement */
	i_not_cpt_mvt_ini++;

}
